
if exists (select * FROM SYS.OBJECTS WHERE object_id = object_id(N'[dbo].[GetZone_Inline]') and type in (N'FN', N'IF', N'TF'))
    DROP FUNCTION [dbo].GetZone_Inline

if(exists(select name from SYS.OBJECTS where (name='zone') and (type='u')))
begin
	DROP TABLE [dbo].[zone]	
end

CREATE TABLE [dbo].[zone](
	[zone_id] [int] IDENTITY(1,1) NOT NULL,
	[country_code] [varchar](2) NOT NULL,
	[zone_name] [varchar](35) NOT NULL,
PRIMARY KEY NONCLUSTERED 
(
	[zone_id] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY],
 CONSTRAINT [idx_country_code] UNIQUE CLUSTERED 
(
	[zone_id] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY],
 CONSTRAINT [idx_zone_name] UNIQUE NONCLUSTERED 
(
	[zone_name] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]


IF EXISTS (SELECT name FROM sys.indexes  
            WHERE name = N'IX_zone_zone_name')   
DROP INDEX IX_zone_zone_name ON [dbo].[timezone]; 

CREATE NONCLUSTERED INDEX IX_zone_zone_name 
    ON [dbo].[zone] (zone_name);  


if(exists(select name from SYS.OBJECTS where (name='country') and (type='u')))
begin
	DROP TABLE [dbo].[country]	
end

CREATE TABLE [dbo].[country](
	[country_code] [varchar](2) NULL,
	[country_name] [varchar](45) NULL,
 CONSTRAINT [country_country_code] UNIQUE CLUSTERED 
(
	[country_code] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

if(exists(select name from SYS.OBJECTS where (name='timezone') and (type='u')))
begin
	DROP TABLE [dbo].[timezone]	
end

CREATE TABLE [dbo].[timezone](
	[zone_id] [int] NOT NULL,
	[abbreviation] [varchar](6) NOT NULL,
	[time_start] [decimal](11, 0) NOT NULL,
	[gmt_offset] [int] NOT NULL,
	[dst] [char](1) NOT NULL
) ON [PRIMARY]

IF EXISTS (SELECT name FROM sys.indexes  
            WHERE name = N'IX_timezone_zone_id')   
    DROP INDEX IX_timezone_zone_id ON [dbo].[timezone]; 

CREATE NONCLUSTERED INDEX IX_timezone_zone_id   
    ON [dbo].[timezone] (zone_id);   

IF EXISTS (SELECT name FROM sys.indexes  
            WHERE name = N'IX_timezone_time_start')   
DROP INDEX IX_timezone_time_start ON [dbo].[timezone]; 

CREATE NONCLUSTERED INDEX IX_timezone_time_start   
    ON [dbo].[timezone] (time_start);   

if(not exists(select name from SYS.OBJECTS where (name='UTCConversionQuery') and (type='u')))
begin
	CREATE TABLE [dbo].[UTCConversionQuery](
		[id] [int] IDENTITY(1,1)  NOT NULL,
		[sql] [nvarchar](MAX) NOT NULL,
		[time_start] [DATETIME] NULL,
		[time_end] [DATETIME] NULL,
		[converted] [bit] NULL,
		[error_msg] [nvarchar](MAX)
		PRIMARY KEY NONCLUSTERED 
		(
			[id] ASC
		)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
	) ON [PRIMARY]
end
